/*****************************************************************************
 *                                                                           *
 *                                HOOK.CPP                                   *
 *---------------------------------------------------------------------------*
 *  First version:  11/07/1994                                               *
 *  Latest release: 11/23/1994    (MSVC++ Version)                           *
 *---------------------------------------------------------------------------*
 *  By Emmanuel Thioux //1994                                                *
 *                                                                           *
 *---------------------------------------------------------------------------* 
 *                                                                           *
 *  I am sorry if the source is not really cool, but I'm not use to work     *
 *  MS Visual C++.                                                           *
 *  I've been bound to modify a couple of thingz for this version.           *
 *  I do not include ctl3d.h, nor ctl3dv2.lib in this example because they   *
 *  are not included with my version of Visual C++. But if you wanna use 'em *
 *  just define the "3DOK" symbol.                                           *
 *  This version is just buggy in the APPLI.CPP. In effect the number of the *
 *  first icon (in SPEEDM.EXE) is not 2 but 1, why ???                       *
 *  Maybe it's because I didn't buid the RC file in the same way.            *
 *                                                                           *
 *  Enjoy.                                                                   *
 *                                                                           *
 * ========================================================================= *
 *                                                                           *
 * I'm pretty sure that some of you (maybe most of you) wonder why I gave the*
 * SOURCE CODE with thew program. No ?                                       *
 * I'm gonna relate you a small story (if you think that will be boring do a *
 * Page down).                                                               *
 * I started programing on a PC in 1989. My first language was... BASIC :-)  *
 * After that in 1990 I started with Turbo Pascal 5.0 and TASM               *
 * At this point to get some information about programming was really        *
 * difficult and especially in France where we have some problems to get     *
 * good books (maybe they don't resist to the trip U.S -> France).           *
 * I think, like lot of other programmers I had a lot of work to do to learn *
 * After Pascal, in 1992 I started C and a bit after C++. Still for DOS      *
 * (DOS RULES !!!!)                                                          *
 * For Windows I really make programs since 1993.                            *
 * My point is: I've had too much difficulties to learn DOS and WINDOWS      *
 * programming by myself. If you have 10 books about that, you are always    *
 * looking for the 11th and so on.                                           *
 * Maybe some people think: "Hey ! I made this wonderful program but I won't *
 * give the source code because the others will copy it.", sometimes the     *
 * reason is just the pride, sometimes is just the MONEY.                    *
 * I think if someone is able to make good things, his/her duty is to help   *
 * other programmers to do the same thing or even better. It's my own sight  *
 * of programming and computer sciences. Maybe lot of people do not share my *
 * point of view and I think this is too bad. Not because I think I'm right  *
 * but because we waste a lot of time to re-invent the wheel. I think highly *
 * on guys like Andrew Schulman or Ralph Brown and all these people who write*
 * articles and books about their own knowledge.                             *
 * I hope you understand better now why I did that.                          *
 * --------------------------------------------------------------------------*
 * And, as I write it in the Readme file the only thing I ask you is just to *
 * put me in the credits of your program(s) if you use this source code.     *
 * Thanks.                                                                   *
 *                                                                           * 
 *                                                      Manu.                *
 *****************************************************************************/

#include <windows.h>
#include <dos.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#ifdef _3DOK
   #include "CTL3D.H"          // 3-D control Header
#endif

#include "Hook.h"
#include <shellapi.h>
#ifndef __WIN32__
  #include <toolhelp.h>
#endif

unsigned RTASKMAN = 0;

// Some external procedures for the Keyborad hook
extern "C" void far EventHook(void);
// Undocumented function
// This one allows you to hook the keyboard and take the control before Windows.
// I used it to get the Ctrl-Esc. And run my own Task Manager.
extern "C" void FAR PASCAL SetEventHook(FARPROC lpfnEventProc);

// I could have find another way to modify my Global variable but...
extern "C" void far SETRTASK(unsigned Value);


//#pragma inline

// Global variables
HINSTANCE MainInstance = NULL;
HDC  MainDC;
HWND MainWindow;
HWND MainActive;
BOOL BarActive = FALSE;
BOOL KeyHook = FALSE;

// Hooks ...
HHOOK PrevHook;       // Messages hook
HHOOK PrevMouseHook;  // Mouse hook
HHOOK PrevShellHook;  // Shell hook

HDC DesktopDC;
FARPROC FarProc;
HOOKPROC THook;

LPSTR ErrorString = new char far[256];
BOOL NewSlot = FALSE;
BOOL ScreenON = TRUE;
BOOL DisplayResources = FALSE;

char* ARGV[10];  // For MSC++ cos' it doesn't have the _argv[] global var !

// Class name of the main window
char* szWinName = "Icon Stuff";
int SLOT = 0;

extern "C" GETDS();

// Differents Handles for the bitmaps and the icons
HBITMAP SmileyOR;
HBITMAP SmileyOldOR;
HBITMAP SmileyDisable;
HBITMAP SmileyOldDisable;
HDC     SmileDC;
HICON   Icon;
WINDOWPLACEMENT wndplc;

NetConnectionDialog WNetConnectionDialog;
NetDisconnectDialog WNetDisconnectDialog;
NetShareAsDialog    WNetShareAsDialog;
NetStopShareDialog  WNetStopShareDialog;

int MouseX, MouseY, MouseXMax, MouseYMax;

// Declaration for the calculator
typedef void (*YO)(int);
YO SpeedCalc;

// Set RTASKMAN to TRUE, then when next timer will occur, MSPEED will run MTASK.EXE
// See MTASK for further information.
void far SETRTASK(unsigned Value)
{
 RTASKMAN = Value;
}

// Display the resources and the clock on the active window caption bar
//#pragma warn -aus
void DrawRes(HWND Window)
{
 HDC TmpDC;
 RECT r;
 HFONT hfont, hfontOld;
 LPSTR pszFace = "MS Serif";
 char  MEM[15] = "Mem: ";
 char  RES[20] = "Res: ";
 int   iPtSize = 7;
 int   XStart, YStart, Caption;
 long  Style;
 time_t ltime;
 struct tm* TM;
#ifndef __WIN32__
 SYSHEAPINFO shi;
#endif

 // Do not display resources on an icon
 if (IsIconic(Window))
      return;
 XStart = GetSystemMetrics(SM_CXSIZE);
 XStart += GetSystemMetrics(SM_CXFRAME);
 YStart = GetSystemMetrics(SM_CYFRAME);
 Caption = GetSystemMetrics(SM_CYCAPTION) - GetSystemMetrics(SM_CYBORDER);
 Style = GetWindowLong(Window, GWL_STYLE);

 if ((Style & WS_SYSMENU) == WS_SYSMENU)
     {
      TmpDC = GetWindowDC(Window);
      if (Window == GetActiveWin())
         {
          // Place the bitmap dependently of the Caption style and the frame
          if ((Style & WS_THICKFRAME) != WS_THICKFRAME)
              {
                YStart-= GetSystemMetrics(SM_CYFRAME);
                //XStart-= GetSystemMetrics(SM_CXFRAME);
              }

          if ((Style & DS_MODALFRAME) == DS_MODALFRAME)
              {
                YStart+= GetSystemMetrics(SM_CXFRAME);
                SmileDC = CreateCompatibleDC(TmpDC);
                SmileyOldDisable = SelectObject(SmileDC, SmileyDisable);
                // Stretch it to fit in the caption
                StretchBlt(TmpDC, XStart, YStart, 16, Caption, SmileDC, 0, 0, 16, 18, SRCCOPY);
                SelectObject(SmileDC, SmileyOldDisable);
                DeleteDC(SmileDC);
              }
          GetWindowRect(Window, &r);
          hfont = CreateFont(-iPtSize , 0, 0, 0, 0, /* specify pt size    */
                 0, 0, 0, 0, 0, 0, 0, 0, pszFace);     /* and face name only */

#ifndef __WIN32__
          shi.dwSize = sizeof(shi);
          SystemHeapInfo(&shi);
          time(&ltime);
          TM = localtime(&ltime);
          sprintf(&MEM[5], "%lu Ko", GetFreeSpace(0) / 1024);
          sprintf(&RES[5], "%d%% - %02d:%02d", ((shi.wUserFreePercent + shi.wGDIFreePercent) >> 1), TM->tm_hour, TM->tm_min);
#endif
          hfontOld = SelectObject(TmpDC, hfont);
          SetTextColor(TmpDC, RGB(255,255,255));
          SetBkMode(TmpDC, OPAQUE);
          SetBkColor(TmpDC, GetPixel(TmpDC, XStart + 18, YStart + 1));
          TextOut(TmpDC, XStart + 18, YStart + 1, MEM, strlen(MEM));
          TextOut(TmpDC, XStart + 18, YStart + 9, RES, strlen(RES));
          SelectObject(TmpDC, hfontOld);
          DeleteObject(hfont);
         }
     ReleaseDC(Window, TmpDC);
    }
}


// Paint the SpeedManu Icon into the caption bar of the active window (Only if it's not a dialog)
//#pragma warn -aus
void PaintBitmap(HWND Window, BOOL Clear, BOOL FORCED)
{
 HDC TmpDC;
 HBRUSH Brush, OBrush;
 POINT rc;
 RECT r;
 int XStart, YStart, Caption;
 static int TooAdd = 0;
 long Style;


 // Do not display the bitmap on an icon
 if (IsIconic(Window))
      return;
 XStart = GetSystemMetrics(SM_CXSIZE);
 XStart += GetSystemMetrics(SM_CXFRAME);
 YStart = GetSystemMetrics(SM_CYFRAME);
 Caption = GetSystemMetrics(SM_CYCAPTION) - GetSystemMetrics(SM_CYBORDER);
 Style = GetWindowLong(Window, GWL_STYLE);

 // Place the bitmap dependently of the Caption style and the frame
 if ((Window == GetActiveWin()) || (FORCED))
      {
        if ((Style & DS_MODALFRAME) == DS_MODALFRAME)
            YStart+= GetSystemMetrics(SM_CXFRAME);
        if ((Style & WS_THICKFRAME) != WS_THICKFRAME)
            {
             YStart-= GetSystemMetrics(SM_CYFRAME);
             XStart-= GetSystemMetrics(SM_CXFRAME);
            }
      }
 TmpDC = GetWindowDC(Window);
 // if we can draw the bitmap hust do it
 if ((!Clear) && ( (Window == GetActiveWin()) || FORCED))
      {
        GetWindowRect(Window, &r);
        rc.x = 0;
        rc.y = 0;
        ClientToScreen(Window, &rc);
        rc.y-=(GetSystemMetrics(SM_CYCAPTION) + GetSystemMetrics(SM_CYMENU));
        MouseX = rc.x + GetSystemMetrics(SM_CXSIZE);
        MouseY = rc.y;
        MouseXMax = MouseX + 16;
        MouseYMax = MouseY + Caption;

        TooAdd = Caption;
        SmileDC = CreateCompatibleDC(TmpDC);
        SmileyOldOR = SelectObject(SmileDC, SmileyOR);
        // Stretch it to fit in the caption
        StretchBlt(TmpDC, XStart, YStart, 16, Caption, SmileDC, 0, 0, 16, 18, SRCCOPY);
        SelectObject(SmileDC, SmileyOldOR);
        DeleteDC(SmileDC);
        if (DisplayResources)
             DrawRes(Window);
      }
 else
      {// else just erase the bitmap
        SelectObject(TmpDC, GetStockObject(NULL_PEN));
        Brush = CreateSolidBrush(GetPixel(TmpDC, XStart+17, YStart+1));
        OBrush = SelectObject(TmpDC, Brush);
        Rectangle(TmpDC, XStart+1, YStart, XStart + TooAdd, YStart + Caption);
        SelectObject(TmpDC, OBrush);
        DeleteObject(Brush);
      }
 ReleaseDC(Window, TmpDC);
}

// Hook for WH_CALLWND

LRESULT CALLBACK Hook(int nCode, WPARAM wParam, LPARAM lParam)
{
 CWPSTRUCT *Info;
 int XStart, YStart, Caption;
 long Style;
 HHOOK InternPrev;
                  
 _asm push ds
 GETDS();
 InternPrev = PrevHook;
 _asm pop  ds
                  
 // just return if the message is not for us
 if (nCode != HC_ACTION)
      {
       return CallNextHookEx(InternPrev, nCode, wParam, lParam);
      }

 // get the info about the message
 Info = (CWPSTRUCT*) lParam;
 switch (Info->message)
     {// All those message have to redraw the bitmap
      case WM_PAINT:
      case WM_SYNCPAINT:
      case WM_NCPAINT:
      case WM_ERASEBKGND:
      case WM_SETFOCUS:
      case WM_PARENTNOTIFY:
      case WM_SETTEXT:
      case WM_SHOWWINDOW:if (IsIconic(Info->hwnd))
                            return 0;
      case WM_MOVE:
      case WM_SIZE:
             {
                if ((GetParent(Info->hwnd) == NULL) && (Info->hwnd == GetActiveWin()))
                     {
                      _asm pusha
                      _asm push ds
                      _asm push es
                      
                      GETDS(); // Get the correct Data segment (sometimes I lose it, so...)
                      Style = GetWindowLong(Info->hwnd, GWL_STYLE);

                      // Just draw the bitmap if the window has a system menu
                      if ((Style & WS_SYSMENU) == WS_SYSMENU)
                            {
                             XStart = GetSystemMetrics(SM_CXSIZE);
                             XStart += GetSystemMetrics(SM_CXFRAME);
                             YStart = GetSystemMetrics(SM_CYFRAME);
                             Caption = GetSystemMetrics(SM_CYCAPTION) - GetSystemMetrics(SM_CYBORDER);

                             if ((Style & DS_MODALFRAME) == DS_MODALFRAME)
                                     YStart+= GetSystemMetrics(SM_CXFRAME);
                             if ((Style & WS_THICKFRAME) != WS_THICKFRAME)
                                     YStart-= GetSystemMetrics(SM_CXFRAME);

                             // Let's the main window draw the bitmap
                             PostMessage(MainWindow, WM_USER + WM_DRAW, (WPARAM) Info->hwnd, (LPARAM) 0);
                            }
                      _asm pop es
                      _asm pop ds
                      _asm popa
                     }
                }
                break;
      }
 return CallNextHookEx(InternPrev, nCode, wParam, lParam);
}

// Hook for the WH_SHELL
// This one is used to stop the screen saver
// But it just works if the screen saver is a Windows one (cos' of the class name)
LRESULT CALLBACK ShellHook(int nCode, WPARAM wParam, LPARAM lParam)
{
 HHOOK PrevHook;
 
 _asm push ds;
 GETDS();
 PrevHook = PrevShellHook;
 _asm pop ds
 
 if (nCode == HSHELL_WINDOWCREATED)  // a window has been created.
      {
       _asm push DS
       GETDS();
       if (ScreenON)
         {
          _asm pop DS
          return CallNextHookEx(PrevHook, nCode, wParam, lParam);
         }
       else
         {                          // test the Class name
          LPSTR Class = new char far[255];
          GetClassName((HWND) wParam, Class, 255);
          if (_fstrcmp(Class, "WindowsScreenSaverClass") != 0)
             {
              delete Class;         // if it's screen saver the destroy it.
              _asm pop DS
              return CallNextHookEx(PrevHook, nCode, wParam, lParam);
             }
          else
             {
              delete Class;
              PostMessage((HWND) wParam, WM_MOUSEMOVE, (WPARAM) 0, (LPARAM) 0x0a0a);
              PostMessage((HWND) wParam, WM_DESTROY, (WPARAM) 0, (LPARAM) 0);
              _asm pop DS
              return CallNextHookEx(PrevHook, nCode, wParam, lParam);
             }
          }
      }
 return CallNextHookEx(PrevHook, nCode, wParam, lParam);
}

// Mouse Hook
LRESULT CALLBACK MouseHook(int nCode, WPARAM wParam, LPARAM lParam)
{
 HHOOK PrevHook;
 MOUSEHOOKSTRUCT *Info;
 long MousePos;
 
 _asm push DS
 GETDS();
 PrevHook = PrevMouseHook;
 _asm pop DS
       
 if (nCode != HC_ACTION)
    {
     return CallNextHookEx(PrevHook, nCode, wParam, lParam);
    }
 if ((wParam != WM_MOUSEMOVE) && (wParam != WM_NCMOUSEMOVE))
     {
      // if right-click on the bitmap then active the toolbar
      if ((wParam == WM_NCRBUTTONDOWN) || (wParam == WM_RBUTTONDOWN))
      {
        Info = (MOUSEHOOKSTRUCT*) lParam;
        if ((GetParent(Info->hwnd) == NULL) && (Info->hwnd == GetActiveWin()))
            {
             _asm pusha
             _asm push ds
             _asm push es
             GETDS();
             if ((Info->pt.x >= MouseX) && (Info->pt.y >= MouseY))
                if ((Info->pt.x <= MouseXMax) && (Info->pt.y <= MouseYMax))
                   {
                    MousePos = ((long) Info->pt.x << 16) + (Info->pt.y);
                    PostMessage(MainWindow, WM_USER + WM_MENU, (WPARAM) Info->hwnd, (LPARAM) MousePos);
                   }
             _asm pop es
             _asm pop ds
             _asm popa
            }
      }
     }
 return CallNextHookEx(PrevHook, nCode, wParam, lParam);
}

BOOL CALLBACK DialogProc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM /*lParam*/);
BOOL CALLBACK SlotDialogProc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam);

// Main Window proc.
// answers to the button queries

long FAR PASCAL _export WndProc(HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
 HWND Prev;
 char App[10] = "App#";
 char NApp[128];
 char *p;
 PAINTSTRUCT PS;
 HANDLE Handle;
 int i = 1;
 BOOL CalcOk = FALSE;
 static Tempo = 0;

 switch (message)
     {
      case WM_CREATE:
          SetTimer(hwnd, 1, 125, NULL);
          do {                         // Set events hook if /TSK specified 
              if (ARGV[i])
                 {
                  strupr(ARGV[i]);
                  if (strcmp(ARGV[i], "/TSK") == 0)
                     {
                      KeyHook = TRUE;
                      SetEventHook((FARPROC) EventHook);
                     }
                 } 
             } while (ARGV[++i]!=NULL);
             
          PaintBitmap(GetActiveWin(), FALSE, TRUE);
          GetProfileString("SpeedManu", "ResourcesDisplay", "NO", NApp, 128);
          if (strcmp(NApp, "YES") == 0)
              SendMessage(hwnd, WM_COMMAND, CM_RES, 0);
          break;

      case WM_USER + WM_DRAW:
          PaintBitmap((HWND) wParam, FALSE, FALSE);
          break;

      case WM_USER + WM_MENU: 
          {
           ShowWindow(hwnd, SW_SHOWNORMAL);
           MainActive = (HWND) wParam;
           PaintBitmap(MainActive, FALSE, TRUE);
           BarActive = TRUE;
           MakeToolBar(hwnd, MouseX + 16, MouseY);
           ShowWindow(hwnd, SW_HIDE);
          } break;
           

      case WM_USER + WM_ERROR:
#ifdef _3DOK      
             Ctl3dRegister(MainInstance);        // setup for 3-d controls (CTL3D.DLL)
             Ctl3dAutoSubclass(MainInstance);    // auto subclassing for all controls
#endif             
             LoadString(MainInstance, wParam, ErrorString, 255);
             MessageBox(0, ErrorString, "Error", MB_OK | MB_ICONEXCLAMATION);
#ifdef _3DOK             
             Ctl3dUnregister(MainInstance);        // unregister the 3D controls
#endif             
             break;

      case WM_COMMAND:
        if (LOWORD(wParam) >= 500)
            {
             itoa(LOWORD(wParam) - 500, &App[4], 10);
             GetProfileString("SpeedManu", App, "Error", NApp, 128);
             p = strchr(NApp, ',');
             p++;
             WinExec(p, SW_SHOWNORMAL);
             break;
            }
#ifdef _3DOK
        if ((LOWORD(wParam) >= IDM_CONNECT) && (LOWORD(wParam) <= IDM_STOPSHARE))
           {
            Ctl3dRegister(MainInstance);        // setup for 3-d controls (CTL3D.DLL)
            Ctl3dAutoSubclass(MainInstance);    // auto subclassing for all controls
           }
#endif             

        switch (LOWORD(wParam))
          {
            case CM_DOS:
                WinExec(getenv("COMSPEC"), SW_SHOWNORMAL);
                return 0;

                case CM_EXIT:
                DestroyWindow(hwnd);
                break;

            case CM_CLOCK:
                WinExec("CLOCK.EXE", SW_SHOWNORMAL);
                break;

            case CM_CALC:
                 do {
                     if (ARGV[i])
                        {
                         strupr(ARGV[i]);
                         if (strcmp(ARGV[i], "/IC") != 0)
                            {
                             WinExec("CALC.EXE", SW_SHOWNORMAL);
                             CalcOk = TRUE;
                            } 
                        }
                    } while (ARGV[++i]!=NULL);
                 if (!CalcOk)
                    {
                     Handle = LoadLibrary("SPEEDDLL.DLL");
                     SpeedCalc = (YO) GetProcAddress(Handle, "SPEEDCALC");
                     if (!SpeedCalc)
                         {
                          FreeLibrary(Handle);
                          SendMessage(hwnd, WM_USER + WM_ERROR, DLL_ERR, 0);
                         }
                     else
                         {
                          SpeedCalc(GetActiveWin());
                          FreeLibrary(Handle);
                         }
                     }
                break;

            case CM_SHUT:
                DestroyWindow(hwnd);
                ExitWindows(0, 0);
                break;

            case CM_SCRSV:
                PostMessage((HWND) 0xFFFF, WM_SYSCOMMAND, SC_SCREENSAVE, 0);
                break;

            case CM_APP:
                     MakeIconBar(MainWindow, MouseX + 16 * (CM_APP - 100), MouseY + 18);
                break;

            case CM_HELP:
                MakeWinHelp();
                break;
                
            case CM_NET:
                NetFuncs(hwnd, MouseX + 16 * (CM_NET - 100), MouseY + 18);
                break;

            case CM_CONF:
#ifdef _3DOK            
                Ctl3dRegister(MainInstance);        // setup for 3-d controls (CTL3D.DLL)
                Ctl3dAutoSubclass(MainInstance);    // auto subclassing for all controls
#endif          
                Prev = GetActiveWin();
                DialogBox(MainInstance, MAKEINTRESOURCE(100), hwnd, (DLGPROC) DialogProc);
                BringWindowToTop(Prev);
#ifdef _3DOK                
                Ctl3dUnregister(MainInstance);        // unregister the 3D controls
#endif                
                break;

            case CM_CANC:
                PaintBitmap(GetActiveWin(), FALSE, FALSE);
                     break;

            case CM_SSON:
                if (ScreenON)
                     ScreenON = FALSE;
                else
                     ScreenON = TRUE;
                break;
            case CM_RES:
                DisplayResources = !DisplayResources;
                break;
            case IDM_CONNECT:
                WNetConnectionDialog(hwnd, 1);
#ifdef _3DOK                
                Ctl3dUnregister(MainInstance);        // unregister the 3D controls
#endif          
                DestroyNet();
                break;
            case IDM_DISCONNECT:
                WNetDisconnectDialog(hwnd, 1);
#ifdef _3DOK                
                Ctl3dUnregister(MainInstance);        // unregister the 3D controls
#endif
                DestroyNet();
                break;
            case IDM_SHARE:
                WNetShareAsDialog(hwnd, 1, "C:\\");
#ifdef _3DOK                
                Ctl3dUnregister(MainInstance);        // unregister the 3D controls
#endif
                DestroyNet(); 
                break;
            case IDM_STOPSHARE:
                WNetStopShareDialog(hwnd, 1, "C:\\");
#ifdef _3DOK
                Ctl3dUnregister(MainInstance);        // unregister the 3D controls
#endif
                DestroyNet();
                break;
           }
          PaintBitmap(GetActiveWin(), FALSE, FALSE);
          break;


      case WM_PAINT:
          BeginPaint(hwnd, &PS);
          SelectObject(PS.hdc, GetStockObject(WHITE_BRUSH));
          Rectangle(PS.hdc, 0, 0, PS.rcPaint.right, PS.rcPaint.bottom);
          EndPaint(hwnd, &PS);
          break;

      case WM_TIMER:
          if (DisplayResources)
             if (Tempo == 8)     // Refresh resource stuff every 1 second
                {                // just to not waste time
                 if (!BarActive)
                   {
                    DrawRes(GetActiveWin());
                    Tempo = 0;
                   }
                }
             else 
                Tempo++;
 
          if (RTASKMAN == 1)     // Ask for the Task Manager ?
             {
              if (WinExec("MTASK.EXE", SW_SHOW) < 32)
                 SendMessage(hwnd, WM_USER + WM_ERROR, MTASKERR, 0L);
              RTASKMAN = 0;
             } 
          break;
        case WM_DESTROY:
          ReleaseDC(hwnd, MainDC);
          UnhookWindowsHookEx((HHOOK) PrevHook);
          UnhookWindowsHookEx((HHOOK) PrevMouseHook);
          UnhookWindowsHookEx((HHOOK) PrevShellHook);
          DeleteObject(SmileyOR);
          DeleteObject(SmileyDisable);
          PaintBitmap(MainActive, TRUE, FALSE);
          if (DisplayResources)
             {
              DisplayResources = FALSE;
              WriteProfileString("SpeedManu", "ResourcesDisplay", "YES");
             }
           else
             WriteProfileString("SpeedManu", "ResourcesDisplay", "NO");
          KillTimer(hwnd, 1);
          if (KeyHook)
             SetEventHook(NULL);
          PostQuitMessage(0);
        }
 return(DefWindowProc(hwnd,message,wParam,lParam));
}

//#pragma warn -aus

BOOL CALLBACK DialogProc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
 static APPLIDESC* APPL = NULL;
 char App[10] = "App#";
 char *AppName = NULL;
 LRESULT OkReady = 0;

 // -----------------------

 LPMEASUREITEMSTRUCT lpmis;
 LPDRAWITEMSTRUCT    lpdis;
 HICON Icon;
 LRESULT j;
 char Number[5] = "0000";
 int Slots;
 char Profile[16] = "App#";
 char *p;
 char Text[32];

 // -----------------------

 switch (msg)
    {
     case WM_INITDIALOG:
        SendDlgItemMessage(hwndDlg, 101, WM_SETTEXT, 0, (long) " ");
        SendDlgItemMessage(hwndDlg, 104, WM_SETTEXT, 0, (long) " ");
        GetProfileString("SpeedManu", "Applicationcount", "Error", Number, 32);
        Slots = atoi(Number);
        for (j = 0; j < 10; j++)
             {
              itoa((int) j, Number, 10);
              strcpy(Profile, "App#");
              strcat(Profile, Number);
              GetProfileString("SpeedManu", Profile, "Error", Text , 128);
              if (strcmp(Text, "Error") != 0)
                 {
                  p = strchr(Text, ',');
                  *p = 0x0;
                  SendDlgItemMessage(hwndDlg, 104, LB_ADDSTRING, 0, (LPARAM) Text);
                 }
              else
                 {
                  strcpy(Text, "Empty Slot #");
                  strcat(Text, Number);
                  SendDlgItemMessage(hwndDlg, 104, LB_ADDSTRING, 0, (LPARAM) Text);
                 }
             }
        EnableWindow(GetDlgItem(hwndDlg, 100), FALSE);
        EnableWindow(GetDlgItem(hwndDlg, 1), FALSE);
        break;

     case WM_MEASUREITEM:
        {
         lpmis = (LPMEASUREITEMSTRUCT) lParam;
         lpmis->itemHeight = 34;
         return TRUE;
        }
     case WM_DRAWITEM:
        {
         lpdis = (LPDRAWITEMSTRUCT) lParam;
         if ((int) lpdis->itemID == -1)
             break;
         switch (lpdis->itemAction)
             {
              case ODA_SELECT:
                  case ODA_DRAWENTIRE:
                      {
                       SelectObject(lpdis->hDC, GetStockObject(WHITE_PEN));
                       SelectObject(lpdis->hDC, GetStockObject(WHITE_BRUSH));
                       Rectangle(lpdis->hDC, lpdis->rcItem.left, lpdis->rcItem.top,
                                lpdis->rcItem.right, lpdis->rcItem.bottom);

                       Icon = ExtractIcon(MainInstance, ARGV[0], lpdis->itemID);
                       SetMapMode(lpdis->hDC, MM_TEXT);
                       DrawIcon(lpdis->hDC, 1, lpdis->rcItem.top, Icon);
                       DestroyIcon(Icon);

                       SendDlgItemMessage(hwndDlg, 104, LB_GETTEXT, lpdis->itemID, (LPARAM) Text);
                       TextOut(lpdis->hDC, 34, lpdis->rcItem.top + 8, Text, strlen(Text));
/*             }
                 break;
              case ODA_FOCUS:
                 {*/
                  if (lpdis->itemState == ODS_SELECTED)
                      {
                        SelectObject(lpdis->hDC, GetStockObject(BLACK_BRUSH));
                        Rectangle(lpdis->hDC, lpdis->rcItem.left, lpdis->rcItem.top,
                                     lpdis->rcItem.right, lpdis->rcItem.bottom);

                        Icon = ExtractIcon(MainInstance, ARGV[0], lpdis->itemID);
                        SetMapMode(lpdis->hDC, MM_TEXT);
                        DrawIcon(lpdis->hDC, 1, lpdis->rcItem.top, Icon);
                  DestroyIcon(Icon);

                  SendDlgItemMessage(hwndDlg, 104, LB_GETTEXT, lpdis->itemID, (LPARAM) Text);
                  SetTextColor(lpdis->hDC, RGB(255, 255, 255));
                  SetBkColor(lpdis->hDC, RGB(0, 0, 0));
                  TextOut(lpdis->hDC, 34, lpdis->rcItem.top + 8, Text, strlen(Text));
                  SendDlgItemMessage(hwndDlg, 103, WM_SETTEXT, 0, (LPARAM) Text);
                  EnableWindow(GetDlgItem(hwndDlg, 100), TRUE);
                 }
               }
             break;
          }
      }

    case WM_COMMAND:
      switch (LOWORD(wParam))
        {
         case IDOK:
           {
            if (APPL)
             {
              APPL->AppliName = new char[30];
              OkReady = SendDlgItemMessage(hwndDlg, 103, WM_GETTEXT, (WPARAM) 30, (LPARAM) APPL->AppliName);
              if (NewSlot)
                 APPL->TotalApp++;
              AppName = new char[256];
              itoa(APPL->TotalApp, AppName, 10);
              WriteProfileString("SpeedManu", "ApplicationCount", AppName);
              itoa(SLOT, &App[4], 10);
              strcpy(AppName, APPL->AppliName);
              strcat(AppName, ",");
              strcat(AppName, APPL->PathName);
              WriteProfileString("SpeedManu", App, AppName);
              delete AppName;
             }
            if (OkReady)
               EndDialog(hwndDlg, 0);
            else
               MessageBox(hwndDlg, "You must enter an name for the aplication", "error", MB_OK);
           } break;
          
         case IDCANCEL:
           EndDialog(hwndDlg, 1);
           break;
          
         case IDAPPLI:
           j = SendDlgItemMessage(hwndDlg, 104, LB_GETCURSEL, 0, 0);
           SendDlgItemMessage(hwndDlg, 104, LB_GETTEXT, (WPARAM) j, (LPARAM) Text);
           if (strncmp(Text, "Empty", 5) == 0)
              NewSlot = TRUE;
           else
              NewSlot = FALSE;
           SLOT = (int) j;
              APPL = LookForAppli(hwndDlg, 101, 102, (int) j);
           EnableWindow(GetDlgItem(hwndDlg, 1), TRUE);
           InvalidateRect(GetDlgItem(hwndDlg, 104), NULL, TRUE);
           UpdateWindow(hwndDlg);
           break;
        }; break;
    }
 return FALSE;
}


// ----------------------------------------------------------------------

int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPSTR lpszCmdLine,
                                                  int /*nCmdShow*/ )
{
 WNDCLASS wndclass;
 MSG msg;
 HWND hwnd;
 HWND Prev = GetActiveWin();
 int  i;
 char far* Token;
 
 SETRTASK(0);
 
 FarProc = (FARPROC) Hook;
 MainInstance = hInstance;
 THook = (HOOKPROC) MakeProcInstance(FarProc, MainInstance);
 PrevHook = SetWindowsHookEx(WH_CALLWNDPROC, THook, hInstance, NULL);

 FarProc = (FARPROC) MouseHook;
 THook = (HOOKPROC) MakeProcInstance(FarProc, MainInstance);
 PrevMouseHook = SetWindowsHookEx(WH_MOUSE, THook, hInstance, NULL);

 FarProc = (FARPROC) ShellHook;
 THook = (HOOKPROC) MakeProcInstance(FarProc, MainInstance);
 PrevShellHook = SetWindowsHookEx(WH_SHELL, THook, hInstance, NULL);

 // for MSC++ move lpszCmdLine into ARGV[]

 ARGV[0] = new char[80];
 GetModuleFileName(hInstance, ARGV[0], 80);
 for (i = 1; i< 10; i++, ARGV[i] = NULL);
 
 // parse the command line
 Token = _fstrtok(lpszCmdLine, " ");
 i = 1;
 do {
     if (Token) 
        ARGV[i++] = _fstrdup(Token);
     Token = _fstrtok(NULL, " ");
    } while (Token);
 
 SmileyOR  = LoadBitmap(hInstance, MAKEINTRESOURCE(103));
 SmileyDisable = LoadBitmap(hInstance, MAKEINTRESOURCE(104));

 wndclass.style         = CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS; // WINDOW STYLE
 wndclass.lpfnWndProc   = WndProc;                          // WND PROC
 wndclass.cbClsExtra    = 0;                                // EXTRAS
 wndclass.cbWndExtra    = 0;                                // EXTRAS
 wndclass.hInstance     = MainInstance;                     // APP INSTANCE
 wndclass.hCursor       = LoadCursor(NULL,IDC_ARROW);       // CURSOR
 wndclass.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
 wndclass.lpszMenuName  = NULL;                             // MENU
 wndclass.lpszClassName = (char*) szWinName;                // CLASS NAME
 RegisterClass((WNDCLASS*) &wndclass);
 hwnd=CreateWindow(szWinName,                      // WINDOW CLASS NAME
                   szWinName,                      // WINDOW CAPTION
                   WS_OVERLAPPEDWINDOW,            // WINDOW STYLE
                   GetSystemMetrics(SM_CXFULLSCREEN), // INITIAL X POSITION
                   GetSystemMetrics(SM_CYFULLSCREEN), // INITIAL Y POSITION
                   34,                             // INITIAL X SIZE
                   34,                             // INITIAL Y SIZE
                   NULL,                           // PARENT WINDOW HANDLE
                   NULL,                           // WINDOW MENU HANDLE
                   MainInstance,                   // PROGRAM INSTANCE HANDLE
                   NULL);                          // CREATION PARAMETERS

    if (hwnd)
      {
       ShowWindow(hwnd, SW_SHOWNORMAL);
       BringWindowToTop(Prev);
       MainWindow = hwnd;
       MainDC = GetDC(hwnd);
      }

 ShowWindow(hwnd, SW_HIDE);
 PaintBitmap(GetActiveWin(), FALSE, FALSE);
 while (GetMessage(&msg,NULL,0,0))
       {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
       }
 return 0;
}
