/******************************************************************************
 *                           MTASK.CPP                                        *
 ******************************************************************************/

#include <Windows.h>
#include <Windowsx.h> //Include it for the message crackers
#include <ctl3d.h>
#include <shellapi.h>
#include <String.h>
#include <toolhelp.h>
#include <stdio.h>

#define IDSWITCH   100
#define IDENDTASK  101
#define IDTASKINFO 102

// Undocunented function used by Taskman.exe to switch to another window
// USER.172 => see the .DEF
extern "C" void far pascal SwitchToThisWindow(HWND hwnd, BOOL bRestore);

// ----------------------------------------------------------------------

BOOL CALLBACK DialogProc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM /*lParam*/);
HINSTANCE MainInstance;

int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/,
                    LPSTR /*lpszCmdLine*/, int /*nCmdShow*/ )
{
 MainInstance = hInstance;
 Ctl3dRegister(MainInstance);        // setup for 3-d controls (CTL3D.DLL)
 Ctl3dAutoSubclass(MainInstance);    // auto subclassing for all controls
 DialogBox(MainInstance, MAKEINTRESOURCE(100), NULL, (DLGPROC) DialogProc);
 Ctl3dUnregister(MainInstance);        // unregister the 3D controls
 return 1;
}

// ===========================================================================

typedef struct tagT_M {
     char      szModuleName[80];
     char      szModule[MAX_MODULE_NAME + 1];
     HMODULE   ModuleHandle;
     HTASK     Task;
     HINSTANCE hInst;
} T_M;

HWND NewWindow;

BOOL CALLBACK EnumWindowsPROC(HWND hwnd, LPARAM lParam)
{
 char Text[150];
 HTASK x;
 GetWindowText(hwnd, Text, 150);
 x = GetWindowTask(hwnd);
 if ((LOWORD(lParam) == x) && (strlen(Text) !=0))
    {
     NewWindow = hwnd;
     return 0;
    }
 return hwnd;
}

char Mem[15];
char Name[150];

JumpToWindow(HINSTANCE hInst)
{
 EnumWindows((WNDENUMPROC) EnumWindowsPROC, (LPARAM) hInst);
}

LRESULT InitDialog(HWND hwnd, HWND /*wParam*/, LPARAM /*lParam*/)
{
 TASKENTRY Task;
 MODULEENTRY Module;
 T_M* ListInfo;
 BOOL OK;
 GLOBALENTRY GEntry;

 long MemModule;
 int Index = 0;
 int SegIndex= 0;

 Task.dwSize = sizeof(Task);
 if (TaskFirst(&Task))
    {
     do {
         ListInfo = new T_M;
         strcpy(ListInfo->szModule, Task.szModule);
         ListInfo->Task = Task.hTask;
         ListInfo->ModuleHandle = Task.hModule;
         ListInfo->hInst = Task.hInst;
         Module.dwSize = sizeof(Module);
         ModuleFindName(&Module, Task.szModule);
         strcpy(ListInfo->szModuleName, Module.szExePath);
         SegIndex = 1;
         MemModule = 0;
         GEntry.dwSize = sizeof(GEntry);
         do {
             OK = GlobalEntryModule(&GEntry, Task.hModule, SegIndex++);
             if (OK)
                MemModule+=GEntry.dwBlockSize;
            } while (OK);
         sprintf(Mem, "\t%lu Ko", (MemModule >> 10));
         strcpy(Name, Task.szModule);
         strcat(Name, Mem);
         SendDlgItemMessage(hwnd, 150, LB_ADDSTRING, 0, (LPARAM) Name);
         SendDlgItemMessage(hwnd, 150, LB_SETITEMDATA, Index++, (LPARAM) ListInfo);
         SegIndex= 0;
         OK = TaskNext(&Task);
        } while (OK);
    }

 return TRUE;
}

LRESULT  MeasureItem(HWND /*hwnd*/, MEASUREITEMSTRUCT FAR* lpmis)
{
 lpmis->itemHeight = 34;
 return TRUE;
}

LRESULT DrawItem(HWND hwnd, const DRAWITEMSTRUCT FAR*  lpdis)
{
 HICON Icon;
 HWND Window;
 HINSTANCE hInst;
 char Text[255];
 int Index;
 T_M  *Info;
 int aTabs[1] = { 200 };

 if ((int) lpdis->itemID == -1)
    return 0;

 switch (lpdis->itemAction)
    {
     case ODA_SELECT:
     case ODA_DRAWENTIRE:
         {
          SendDlgItemMessage(hwnd, 150, LB_GETTEXT, lpdis->itemID, (LPARAM) Text);
          Info = (T_M*) SendDlgItemMessage(hwnd, 150, LB_GETITEMDATA, lpdis->itemID, 0L);
          SelectObject(lpdis->hDC, GetStockObject(WHITE_PEN));
          SelectObject(lpdis->hDC, GetStockObject(WHITE_BRUSH));
          Rectangle(lpdis->hDC, lpdis->rcItem.left, lpdis->rcItem.top,
                    lpdis->rcItem.right, lpdis->rcItem.bottom);

          Icon = ExtractIcon(MainInstance, Info->szModuleName, 0);
          SetMapMode(lpdis->hDC, MM_TEXT);
          DrawIcon(lpdis->hDC, 1, lpdis->rcItem.top, Icon);
          DestroyIcon(Icon);
          SetTextColor(lpdis->hDC, RGB(0, 0, 0));
          SetBkColor(lpdis->hDC, RGB(255, 255, 255));

          SendDlgItemMessage(hwnd, 150, LB_GETTEXT, lpdis->itemID, (LPARAM) Text);
          TabbedTextOut(lpdis->hDC,        /* handle of device context   */
              34, lpdis->rcItem.top + 8,   /* starting coordinates       */
              Text,                        /* address of text            */
              lstrlen(Text),               /* number of characters       */
              sizeof(aTabs) / sizeof(int), /* number of tabs in array    */
              aTabs,                       /* array for tab positions    */
              0);                          /* x-coord. for tab expanding */

          if (lpdis->itemState == ODS_SELECTED)
             {
              SelectObject(lpdis->hDC, GetStockObject(BLACK_BRUSH));
              Rectangle(lpdis->hDC, lpdis->rcItem.left, lpdis->rcItem.top,
                        lpdis->rcItem.right, lpdis->rcItem.bottom);

              Icon = ExtractIcon(MainInstance, Info->szModuleName, 0);
              SetMapMode(lpdis->hDC, MM_TEXT);
              DrawIcon(lpdis->hDC, 1, lpdis->rcItem.top, Icon);
              DestroyIcon(Icon);

              SendDlgItemMessage(hwnd, 150, LB_GETTEXT, lpdis->itemID, (LPARAM) Text);
              SetTextColor(lpdis->hDC, RGB(255, 255, 255));
              SetBkColor(lpdis->hDC, RGB(0, 0, 0));
              TabbedTextOut(lpdis->hDC,        /* handle of device context   */
                  34, lpdis->rcItem.top + 8,   /* starting coordinates       */
                  Text,                        /* address of text            */
                  lstrlen(Text),               /* number of characters       */
                  sizeof(aTabs) / sizeof(int), /* number of tabs in array    */
                  aTabs,                       /* array for tab positions    */
                  0);                          /* x-coord. for tab expanding */
             }
          }
    }
 return FALSE;
}

LRESULT Command(HWND hwnd, int id, HWND /*hwndCtl*/, UINT /*Notify*/)
{
 T_M  *Info;
 long Sel;
 switch (id)
   {
    case IDSWITCH:
      {
       Sel = SendDlgItemMessage(hwnd, 150, LB_GETCURSEL, 0, 0);
       if (Sel!=LB_ERR)
          {
           Info = (T_M*) SendDlgItemMessage(hwnd, 150, LB_GETITEMDATA, Sel, 0L);
           Sel = TaskGetCSIP(Info->Task);
           TaskSwitch(Info->Task, Sel);
           JumpToWindow(Info->Task);
           EndDialog(hwnd, 1);
           SwitchToThisWindow(NewWindow, TRUE);
           break;
          }
      }
    case IDENDTASK:
      {
       Sel = SendDlgItemMessage(hwnd, 150, LB_GETCURSEL, 0, 0);
       if (Sel!=LB_ERR)
          {
           Info = (T_M*) SendDlgItemMessage(hwnd, 150, LB_GETITEMDATA, Sel, 0L);
           TerminateApp(Info->Task, NO_UAE_BOX);
          }
      }
    case IDCANCEL:
      EndDialog(hwnd, 1);
   }
 return FALSE;
}


#pragma warn -aus
BOOL CALLBACK DialogProc(HWND hwndDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
 switch (msg)
        {
         HANDLE_MSG(hwndDlg, WM_INITDIALOG, InitDialog);
         HANDLE_MSG(hwndDlg, WM_MEASUREITEM, MeasureItem);
         HANDLE_MSG(hwndDlg, WM_DRAWITEM, DrawItem);
         HANDLE_MSG(hwndDlg, WM_COMMAND, Command);
         case WM_DESTROY:
            PostQuitMessage(0);
         default:
            return FALSE;
        }
}

